/* soundmosaic, Copyright (c) 2001-2007 Steven Hazel <sah@thalassocracy.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */
#ifndef __SM_UTILS_H__
#define __SM_UTILS_H__

int interlace (const int16_t *in, int16_t *out, int length, int channels);
int deinterlace (const int16_t *in, int16_t *out, int length, int channels);
void range(const int16_t *data, int32_t length, int16_t *max, int16_t *min);
int32_t amplitude(const int16_t *data, int32_t length);
int16_t middle(const int16_t *data, int32_t length);
int16_t mean(const int16_t *data, int32_t length);
void mean_shift(const int16_t *in, int16_t *out, int32_t length,
                int16_t newmean);
void scale_ampl(const int16_t *in, int16_t *out, int32_t length,
                int32_t newampl);
void scale_mag(const int16_t *in, int16_t *out, int32_t length,
               int64_t newmag);
int64_t correlation(const int16_t *a, const int16_t *b, int32_t length);
int64_t magnitude(const int16_t *data, int32_t length);

#endif /* __SM_UTILS_H__ */
