/* soundmosaic, Copyright (c) 2001-2007 Steven Hazel <sah@thalassocracy.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */
#ifndef __SOUNDMOSAIC_H__
#define __SOUNDMOSAIC_H__

#include <sys/types.h>

#define SOUNDMOSAIC_SUCCESS           1
#define SOUNDMOSAIC_INVALID_TILE_SIZE 2

typedef struct {
  int16_t **src;
  int32_t src_len;
  int src_channels;
  void (*draw_match)(int16_t *target_tile,
                     int16_t *source_tile,
                     int32_t tile_size);
} soundmosaic_state;

soundmosaic_state *soundmosaic_init(int16_t **src, int32_t src_len,
                                    int src_channels,
                                    void (*draw_match)(int16_t *target_tile,
                                                       int16_t *source_tile,
                                                       int32_t tile_size));

void soundmosaic_free(soundmosaic_state *self);

int soundmosaic(const soundmosaic_state *self,
                int16_t *tgtbuffer,
                int16_t *outbuffer,
                int32_t tile_size,
                int partition);

int soundmosaic_collate(const int16_t *target,
                        const int16_t *src1,
                        const int16_t *src2,
                        int16_t *output,
                        int32_t tile_size);

#endif /* __SOUNDMOSAIC_H__ */
